//#-#   Fichier rchbruteJava.java issu de galg -a rchbruteJava.alg -o java
//#-#  ===================================================================
//#-#      13/09/2001 17:0.17

//#########################################################
//                                                        #
//                                                        #
//  rchbrut.alg : brutesearch, auteur (gH)                #
//                                                        #
//                                                        #
//#########################################################
//                                                        #
// source : Algorithms, second edition                    #
//          pages 279, 280                                #
//          R. Sedgewick, Addison-Wesley 1988             #
//                                                        #
//#########################################################
//                                                        #
//                                                        #
//  recherche "brute" du tableau P dans le tableau A      #
//  (en anglais : P pour pattern, A pour array)           #
//  les variables sont renommes tabP et tabA             #
//  pour plus de lisibilit.   le tableau tabP contient   #
//  les codes ascii de la phrase                          #
//                                                        #
//      "A STRING SEARCHING EXAMPLE CONSISTING OF..."     #
//                                                        #
//  et le tableau tabA ceux du mot   "STING"              #
//                                                        #
//                                                        #
//#########################################################

//#-#  La ligne suivante provient d'un ajout via le code #: 
import java.io.* ;
class rchbruteJava { 


//#-#  Ajout de longueur.java via le code #> 

public static int longueur(String chen) {
  return chen.length() ;
} // fin de longueur

//#-#  Fin d'ajout de longueur.java via le code #> 
//#-#  Ajout de codeAscii.java via le code #> 

public static int codeAscii(String chen) {
  char uncar = chen.charAt(0) ;
  return Character.getNumericValue(uncar) ;
} // fin de codeAscii

//#-#  Fin d'ajout de codeAscii.java via le code #> 
//#-#  Ajout de sousChaine.java via le code #> 

public static String sousChaine(String chen, int debut, int longueur) {

  String sous_chaine = ""  ;
  try   { sous_chaine = chen.substring(debut-1,debut+longueur-1) ; }
  catch (StringIndexOutOfBoundsException erreurSC) {
     System.out.println(erreurSC.getMessage());
     System.out.println(" erreurSC pour sousChainee *"+chen+"* avec "+debut+" et "+longueur);
     System.exit(-1) ;
  } // fin de catch

  return sous_chaine ;

} // fin de sousChaine

//#-#  Fin d'ajout de sousChaine.java via le code #> 
//#-#  Ajout de copies.java via le code #> 

public static String copies(String motif, int repet) {

  String chen = "" ;
  for (int ifois =1 ; ifois <= repet ; ifois++) {
      chen = motif + chen ;
  } ; // fin de pour

  return chen ;

} // fin de copies

//#-#  Fin d'ajout de copies.java via le code #> 
//#-#  Ajout de format.java via le code #> 

public static String format(int nombre, int longueur) {

  String chen = Integer.toString(nombre) ;
  while (chen.length() < longueur) { chen = " " + chen ; } ;
  return chen ;

} // fin de format

//#-#  Fin d'ajout de format.java via le code #> 
//#-#  Ajout de concatene.java via le code #> 

public static String concatene(String un, String deux) {
  return un + deux ;
} // fin de concatene

//#-#  Fin d'ajout de concatene.java via le code #> 

//#-#  La ligne suivante provient d'un ajout via le code #: 
public static void main(String args[]) {
//#-#  La ligne suivante provient d'un ajout via le code #: 
// dbut de la mthode main()

//#-#  La ligne suivante provient d'un ajout via le code #: 
String chP    = "" ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
String chA    = "" ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int M         = 0 ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int N         = 0 ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int[]         tabP ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int[]         tabA ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int i         = 0 ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int j         = 0 ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
String milieu = ""  ;

chP = "STING" ;
chA = "A STRING SEARCHING EXAMPLE CONSISTING OF..." ;

// conversion des chaines en tableaux

M = longueur(chP) ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
tabP = new int[M + 1 ] ;
for (int ind=1; ind<=M; ind++) { 
  tabP[ind] = codeAscii(sousChaine(chP, ind, 1)) ;
} ; // ind de1a longueur(chP)

N = longueur(chA) ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
tabA = new int[N + 1 ] ;
for (int ind=1; ind<=N; ind++) { 
  tabA[ind] = codeAscii(sousChaine(chA, ind, 1)) ;
} ; // ind de1a longueur(chA)


// algorithme de recherche

i = 1 ;
j = 1 ;

//# il n'y pas de structure REPETER en Java alors on
//# remplace la boucle REPETER par une boucle TANT QUE
//# rpter
while ((j <= M) && (i <= N)) { 

  if (tabA[i] == tabP[j]) { 
     i = i + 1 ;
           j = j + 1 ;
     }
else
{ i = i - j + 2 ;
           j = 1 ;
  } ; // tabA[i] = tabP[i]

// jusqu' (j>M) ou (i>N)
} ; // (j<=M) et (i<=N)

// affichage du rsultat

if (j > M) { 
    System.out.println(chP+" vue dans "+chA+"  partir de la position "+(i - M)) ;

   }
else
{  System.out.println(chP+" non vue dans "+chA) ;

} ; // j>M


// dtail des tableaux (on suppose M < N)

 System.out.println(" Elment tableau P  tableau A ") ;


for (int ind=1; ind<=N; ind++) { 
   if ((ind <= M)) { 
       milieu = concatene(format(tabP[ind], 8), " ") ;
             milieu = concatene(milieu, sousChaine(chP, ind, 1)) ;
       }
else
{ milieu = copies(" ", 10) ;
   } ; // (ind<=M)
    System.out.println(format(ind, 3)+" : "+milieu+format(tabA[ind], 8)+sousChaine(chA, ind, 1)) ;

} ; // ind de1a N
} // fin de la mthode main()
} // fin de la classe rchbruteJava 

//#-#   Fin de traduction pour rchbruteJava.java via de galg -a rchbruteJava.alg -o java
