(* ##-#   Fichier macnaughtonpascal.pas issu de galg -a macnaughtonpascal.alg -o pascal *)
(* ##-#  ============================================================================== *)
(* ##-#      12/09/2001 11:0.14 *)

(* ############################################################## *)
(* #                                                            # *)
(* #   macNaughton.alg : affectation de taches selon            # *)
(* #                   la mthode de mac Naughton               # *)
(* #   auteur (gH)                                              # *)
(* #                                                            # *)
(* #                                                            # *)
(* ############################################################## *)
(* #                                                            # *)
(* #   rfrences :  Cormen, Leiserson et Rivest                # *)
(* #                 Introduction to algorithms, MIT Press      # *)
(* #                                                            # *)
(* ############################################################## *)
(* #                                                            # *)
(* #                                                            # *)
(* # avec nbMachines qui doivent effectuer nbTaches et sachant  # *)
(* # que la tache numro i dure dureeTache[ i] comment rpartir # *)
(* # les taches ? la dure est en heure et les taches sont      # *)
(* # morcelables heure par heure.                               # *)
(* #                                                            # *)
(* #                                                            # *)
(* ############################################################## *)

PROGRAM macnaughtonpascal ; 


(* ##-#  Ajout de max.pas via le code #>  *)

function max( vala,valb : integer ) : integer ;
begin
 if vala > valb then max := vala else max := valb ;
end ;

(* ##-#  Fin d'ajout de max.pas via le code #>  *)
(* ##-#  Ajout de format.pas via le code #>  *)

function format( nombre : integer ; longueur : integer ) : string ;
  var chaine : string ;
begin
  str(nombre:longueur,chaine) ;
  format := chaine ;
end ;

(* ##-#  Fin d'ajout de format.pas via le code #>  *)
(* ##-#  Ajout de copies.pas via le code #>  *)

function copies( motif : string ; repet : integer ) : string ;
 var ind : integer ; chaine : string ;
begin
  chaine := '' ;
  for ind := 1 to repet do begin
      chaine := chaine + motif ;
  end ;
  copies := chaine ;
end ;

(* ##-#  Fin d'ajout de copies.pas via le code #>  *)

(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
var  nbMachines : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
nbTaches     : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
dureeTache   : array[1..10] of integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
somDuree     : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
indTache     : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
dureeCour    : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
dureeMax     : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
dureeMin     : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
machineTacheNumero : array[1..10,1..10] of integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
machineTacheDuree  : array[1..10,1..10] of integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
nbTache      : array[1..10] of integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
indMachine   : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
machineCour  : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
tempsPris    : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
resteTemps   : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
tacheCour    : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
nbTacheCour  : integer ;

(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
BEGIN

(* # 0.  Affectations arbitraires pour tester l'exemple fourni *)
(* #     dans le cours vu sur le web  l'adresse *)


nbMachines := 3 ;
nbTaches := 6 ;

dureeTache[ 1 ] := 5 ;
dureeTache[ 2 ] := 3 ;
dureeTache[ 3 ] := 4 ;
dureeTache[ 4 ] := 5 ;
dureeTache[ 5 ] := 2 ;
dureeTache[ 6 ] := 5 ;


(* # 1. Calcul de la dure minimale *)

somDuree := 0 ;
for indTache := 1 to nbTaches do begin 
     dureeCour := dureeTache[ indTache ] ;
     somDuree := somDuree  +  dureeCour ;
     if indTache  =  1 
        then begin  dureeMax := dureeCour ;
        end else begin 
              if dureeCour  >  dureeMax 
                 then begin  dureeMax := dureeCour ;
              end ; (* # dureeCour > dureeMAx *)
     end ; (* # indTache=1 *)
end ; (* # indTache de1a nbTaches *)
dureeMin :=  max( trunc(somDuree   /   nbMachines)  ,  dureeMax)  ;



(* # 2. Affectation des taches aux machines *)


(* # 2.1 Initialisation du tableau de rpartititon *)

for indTache := 1 to nbTaches do begin 
     nbTache[ indTache ] := 0 ;
     for indMachine := 1 to nbMachines do begin 
           machineTacheNumero[ indTache,indMachine ] := 0 ;
           machineTacheDuree[ indTache,indMachine ] := (  -  1) ;
     end ; (* # indMachine de1a nbMachines *)
end ; (* # indTache de1a nbTaches *)


(* # 2.2 Boucle d'affectation *)

tempsPris := 0 ;
machineCour := 1 ;

for indTache := 1 to nbTaches do begin 
    dureeCour := dureeTache[ indTache ] ;

    if tempsPris  +  dureeCour  <=  dureeMin 

       then begin  (* # on peut affecter toute la tache a la machine courante *)

             tacheCour := nbTache[ machineCour ]  +  1 ;
             nbTache[ machineCour ] := tacheCour ;
             machineTacheNumero[ machineCour,tacheCour ] := indTache ;
             machineTacheDuree[ machineCour,tacheCour ] := dureeCour ;
             tempsPris := tempsPris  +  dureeCour ;
             if tempsPris  =  dureeMin 
                then begin  machineCour := machineCour  +  1 ;
                      tempsPris := 0 ;
             end ; (* # tempsPris = dureeMin *)

       end else begin (* # on n'a le droit d'affecter qu'une partie a la machine courante *)

             tacheCour := nbTache[ machineCour ]  +  1 ;
             nbTache[ machineCour ] := tacheCour ;
             machineTacheNumero[ machineCour,tacheCour ] := indTache ;
             resteTemps := dureeMin  -  tempsPris ;
             machineTacheDuree[ machineCour,tacheCour ] := resteTemps ;

             (* # et on affecte ce qui reste a la machine suivante *)

             machineCour := machineCour  +  1 ;
             tacheCour := nbTache[ machineCour ]  +  1 ;
             nbTache[ machineCour ] := tacheCour ;
             machineTacheNumero[ machineCour,tacheCour ] := indTache ;
             machineTacheDuree[ machineCour,tacheCour ] := dureeCour  -  resteTemps ;
             tempsPris := dureeCour  -  resteTemps ;

    end ; (* # tempsPris+dureeTache[ tacheCour ] <=  dureeMin *)

end ; (* # indTache de1a nbTaches *)


(* # 3. Affichage des donnes et des rpartitions *)

writeln( ' Il y avait ',nbMachines,' machines et ',nbTaches,' taches  rpartir.' ) ; 
writeln( ' Voici la dure des taches : ' ) ; 
writeln( '   Tache    Dure (en heures)' ) ; 
for indTache := 1 to nbTaches do begin 
     writeln(  format(indTache ,  8) , format(dureeTache[ indTache ] ,  8)  ) ; 
end ; (* # indTache de1a nbTaches *)


writeln( '' ) ; 
writeln( ' La dure minimale calcule est ',dureeMin,' heures.' ) ; 
writeln( '' ) ; 


for indMachine := 1 to nbMachines do begin 
    writeln( '  -- machine ',indMachine,' : ' ) ; 
    nbTacheCour := nbTache[ indMachine ] ;
    if nbTacheCour  >  0 
       then begin  
             for indTache := 1 to nbTacheCour do begin 
                  dureeCour := machineTacheDuree[ indMachine,indTache ] ;
                  tacheCour := machineTacheNumero[ indMachine,indTache ] ;
                  writeln(  copies('  ' ,  6) ,' tache ',tacheCour,' dure ',dureeCour ) ; 
             end ; (* # indTache de1 nbTacheCour *)
    end ; (* # numMachine > 0 *)
end ; (* # indTache de1a nbTaches *)

END.

(* ##-#   Fin de traduction pour macnaughtonpascal.pas via de galg -a macnaughtonpascal.alg -o pascal *)
