#  (gH)   --  algoFuncs.pm  ;  TimeStamp (unix) : 06 Aot 01 00:19

#####################################################################

 package  algoFuncs ;
 require  Exporter ;
 @ISA     = qw(Exporter) ;

@EXPORT  = (<<"FIN_DE_LA_LISTE_DES_FONCTIONS" =~ m/^\s*(.+)/xgm) ;
  concatene
  copies
  date
  entier
  entierAuHasard
  format
  heure
  maju
  max
  nbParametres
  parametre
  sousChaine
FIN_DE_LA_LISTE_DES_FONCTIONS

#####################################################################

sub  concatene  { # met bout  bout deux chaines
  return( join(" ",@_) ) ;
} ; # fin sub concatene

#####################################################################

sub  copies  {
  return( $_[0] x $_[1] ) ;
} ; # fin sub copies

#####################################################################

sub date { # prsente proprement la date d'aujourdhui
   ($sec,$min,$hour,$mday,$mmon,$year,$jda)=localtime();
   $mmon = $mmon + 1 ;
   $year = $year + 1900 ;
   if (length($sec)<2)  { $sec = "0$sec" } ;
   if (length($mday)<2) { $mday = "0$mday" } ;
   if (length($mmon)<2) { $mmon = "0$mmon" } ;
   return "$mday/$mmon/$year" ;
 } ; # fin sub date

#####################################################################

sub  entier  {
  # renvoie "vrai" si le paramtre est un entier ventuellement sign
  my $parm_entier = $_[0] ;
  return $parm_entier =~ /^[+-]?\d+$/ ;
} ; # fin sub entier

#####################################################################

sub  entierAuHasard  {
 my ($hvmin,$hvmax) = @_ ;
 return int($hvmin + rand($hvmax-$hvmin+1))  ;
} ; # fin sub entierAuHasard

#####################################################################

sub  format  {
  return( sprintf("%$_[1]d",$_[0]) ) ;
} ; # fin sub format

#####################################################################

sub heure { # prsente proprement l'heure courante
   ($sec,$min,$hour,$mday,$mmon,$year,$jda)=localtime();
   $mmon = $mmon + 1 ;
   $year = $year + 1900 ;
   if (length($sec)<2)  { $sec = "0$sec" } ;
   if (length($mday)<2) { $mday = "0$mday" } ;
   if (length($mmon)<2) { $mmon = "0$mmon" } ;
   return "$hour:$min.$sec" ;
 } ; # fin sub heure

#####################################################################

sub maju { # passe en majuscules y compris les caractres accentus
  my $parm = $_[0] ;
  $parm =~ s//A/g ;
  $parm =~ s//A/g ;
  $parm =~ s//C/g ;
  $parm =~ s//E/g ;
  $parm =~ s//E/g ;
  $parm =~ s//E/g ;
  $parm =~ s//I/g ;
  $parm =~ s//O/g ;
  $parm =~ s//U/g ;
  $parm =~ s//U/g ;
  return uc($parm) ;
} ; # fin sub maju

#####################################################################

sub  max  {
  if ($_[0]>$_[1]) { return $_[0] ; } else { return $_[1] ; } ;
} ; # fin sub max

#####################################################################

sub  nbParametres  {
  return( 1 + $#ARGV ) ;
} ; # fin sub nbParametres

#####################################################################

sub  parametre  {
  return( $ARGV[ -1 + $_[0] ] ) ;
} ; # fin sub parametre

#####################################################################

sub  sousChaine  {
  return( substr($_[0],$_[1]-1,$_[2]) ) ;
} ; # fin sub sousChaine

#####################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
