##-#   Fichier macnaughtonPerl.pl issu de galg -a macnaughtonPerl.alg -o perl
##-#  =======================================================================
##-#      12/09/2001 11:0.35

##############################################################
#                                                            #
#   macNaughton.alg : affectation de taches selon            #
#                   la mthode de mac Naughton               #
#   auteur (gH)                                              #
#                                                            #
#                                                            #
##############################################################
#                                                            #
#                                                            #
#   rfrences :  Cormen, Leiserson et Rivest                #
#                 Introduction to algorithms, MIT Press      #
#                                                            #
##############################################################
#                                                            #
#                                                            #
# avec nbMachines qui doivent effectuer nbTaches et sachant  #
# que la tache numro i dure dureeTache[ i] comment rpartir #
# les taches ? la dure est en heure et les taches sont      #
# morcelables heure par heure.                               #
#                                                            #
#                                                            #
##############################################################

# 0.  Affectations arbitraires pour tester l'exemple fourni
#     dans le cours vu sur le web  l'adresse


$nbMachines = 3  ; 
$nbTaches = 6  ; 

$dureeTache[ 1 ] = 5  ; 
$dureeTache[ 2 ] = 3  ; 
$dureeTache[ 3 ] = 4  ; 
$dureeTache[ 4 ] = 5  ; 
$dureeTache[ 5 ] = 2  ; 
$dureeTache[ 6 ] = 5  ; 


# 1. Calcul de la dure minimale

$somDuree = 0  ; 
for ( $indTache = 1  ;  $indTache <= $nbTaches  ; $indTache++ ) { 
     $dureeCour = $dureeTache[ $indTache ]  ; 
     $somDuree = $somDuree + $dureeCour  ; 
     if ($indTache == 1 ) { 
        $dureeMax = $dureeCour  ; 
        }
 else { 
              if ($dureeCour > $dureeMax ) { 
                 $dureeMax = $dureeCour  ; 
              } ; # dureeCour > dureeMAx
     } ; # indTache=1
} ; # indTache de1a nbTaches
$dureeMin = &max( $somDuree / $nbMachines , $dureeMax )  ; 



# 2. Affectation des taches aux machines


# 2.1 Initialisation du tableau de rpartititon

for ( $indTache = 1  ;  $indTache <= $nbTaches  ; $indTache++ ) { 
     $nbTache[ $indTache ] = 0  ; 
     for ( $indMachine = 1  ;  $indMachine <= $nbMachines  ; $indMachine++ ) { 
           $machineTacheNumero[ $indTache  ][  $indMachine ] = 0  ; 
           $machineTacheDuree[ $indTache  ][  $indMachine ] = ( - 1)  ; 
     } ; # indMachine de1a nbMachines
} ; # indTache de1a nbTaches


# 2.2 Boucle d'affectation

$tempsPris = 0  ; 
$machineCour = 1  ; 

for ( $indTache = 1  ;  $indTache <= $nbTaches  ; $indTache++ ) { 
    $dureeCour = $dureeTache[ $indTache ]  ; 

    if ($tempsPris + $dureeCour <= $dureeMin ) { 

       # on peut affecter toute la tache a la machine courante

             $tacheCour = $nbTache[ $machineCour ] + 1  ; 
             $nbTache[ $machineCour ] = $tacheCour  ; 
             $machineTacheNumero[ $machineCour  ][  $tacheCour ] = $indTache  ; 
             $machineTacheDuree[ $machineCour  ][  $tacheCour ] = $dureeCour  ; 
             $tempsPris = $tempsPris + $dureeCour  ; 
             if ($tempsPris == $dureeMin ) { 
                $machineCour = $machineCour + 1  ; 
                      $tempsPris = 0  ; 
             } ; # tempsPris = dureeMin

       }
 else { # on n'a le droit d'affecter qu'une partie a la machine courante

             $tacheCour = $nbTache[ $machineCour ] + 1  ; 
             $nbTache[ $machineCour ] = $tacheCour  ; 
             $machineTacheNumero[ $machineCour  ][  $tacheCour ] = $indTache  ; 
             $resteTemps = $dureeMin - $tempsPris  ; 
             $machineTacheDuree[ $machineCour  ][  $tacheCour ] = $resteTemps  ; 

             # et on affecte ce qui reste a la machine suivante

             $machineCour = $machineCour + 1  ; 
             $tacheCour = $nbTache[ $machineCour ] + 1  ; 
             $nbTache[ $machineCour ] = $tacheCour  ; 
             $machineTacheNumero[ $machineCour  ][  $tacheCour ] = $indTache  ; 
             $machineTacheDuree[ $machineCour  ][  $tacheCour ] = $dureeCour - $resteTemps  ; 
             $tempsPris = $dureeCour - $resteTemps  ; 

    } ; # tempsPris+dureeTache[ tacheCour ] <=  dureeMin

} ; # indTache de1a nbTaches


# 3. Affichage des donnes et des rpartitions

print " Il y avait " ." ". $nbMachines ." ". " machines et " ." ". $nbTaches ." ". " taches  rpartir."."\n" ; 
print " Voici la dure des taches : "."\n" ; 
print "   Tache    Dure (en heures)"."\n" ; 
for ( $indTache = 1  ;  $indTache <= $nbTaches  ; $indTache++ ) { 
     print &format( $indTache , 8  ) ." ". &format( $dureeTache[ $indTache ] , 8  )."\n" ; 
} ; # indTache de1a nbTaches


print ""."\n" ; 
print " La dure minimale calcule est " ." ". $dureeMin ." ". " heures."."\n" ; 
print ""."\n" ; 


for ( $indMachine = 1  ;  $indMachine <= $nbMachines  ; $indMachine++ ) { 
    print "  -- machine  " ." ". $indMachine ." ". " : "."\n" ; 
    $nbTacheCour = $nbTache[ $indMachine ]  ; 
    if ($nbTacheCour > 0 ) { 
       
             for ( $indTache = 1  ;  $indTache <= $nbTacheCour  ; $indTache++ ) { 
                  $dureeCour = $machineTacheDuree[ $indMachine ][ $indTache ]  ; 
                  $tacheCour = $machineTacheNumero[ $indMachine ][ $indTache ]  ; 
                  print &copies( " " , 6  ) ." ". " tache " ." ". $tacheCour ." ". " dure " ." ". $dureeCour."\n" ; 
             } ; # indTache de1 nbTacheCour
    } ; # numMachine > 0
} ; # indTache de1a nbTaches

##-#  Ajout de max.pl via le code #> 


sub  max  {
  if ($_[0]>$_[1]) { return $_[0] ; } else { return $_[1] ; } ;
} ; # fin sub max

##-#  Fin d'ajout de max.pl via le code #> 
##-#  Ajout de format.pl via le code #> 

sub  format  {
  return( sprintf("%$_[1]d",$_[0]) ) ;
} ; # fin sub format

##-#  Fin d'ajout de format.pl via le code #> 
##-#  Ajout de copies.pl via le code #> 

sub  copies  {
  return( $_[0] x $_[1] ) ;
} ; # fin sub copies

##-#  Fin d'ajout de copies.pl via le code #> 

##-#   Fin de traduction pour macnaughtonPerl.pl via de galg -a macnaughtonPerl.alg -o perl
