##-#   Fichier rchbrutePerl.pl issu de galg -a rchbrutePerl.alg -o perl
##-#  =================================================================
##-#      29/07/2001 13:34.51

##########################################################
#                                                        #
#                                                        #
#  rchbrut.alg : brutesearch, auteur (gH)                #
#                                                        #
#                                                        #
##########################################################
#                                                        #
# source : Algorithms, second edition                    #
#          pages 279, 280                                #
#          R. Sedgewick, Addison-Wesley 1988             #
#                                                        #
##########################################################
#                                                        #
#                                                        #
#  recherche "brute" du tableau P dans le tableau A      #
#  (en anglais : P pour pattern, A pour array)           #
#  les variables sont renommes tabP et tabA             #
#  pour plus de lisibilit.   le tableau tabP contient   #
#  les codes ascii de la phrase                          #
#                                                        #
#      "A STRING SEARCHING EXAMPLE CONSISTING OF..."     #
#                                                        #
#  et le tableau tabA ceux du mot   "STING"              #
#                                                        #
#                                                        #
##########################################################


$chP = "STING"  ; 
$chA = "A STRING SEARCHING EXAMPLE CONSISTING OF..."  ; 

# conversion des chaines en tableaux

$M = length($chP )  ; 
for ( $ind = 1  ;  $ind <= $M  ; $ind++ ) { 
  $tabP[ $ind ] = ord(&sousChaineZero($chP , $ind , 1 ) )  ; 
} ; # ind de1a _longueur(chP)

$N = length($chA )  ; 
for ( $ind = 1  ;  $ind <= $N  ; $ind++ ) { 
  $tabA[ $ind ] = ord(&sousChaineZero($chA , $ind , 1 ) )  ; 
} ; # ind de1a longueur(chA)


# algorithme de recherche

$i = 1  ; 
$j = 1  ; 

do { ; 

  if ($tabA[ $i ]  ==  $tabP[ $j ]) { 
     $i = $i + 1  ; 
           $j = $j + 1  ; 
     }
 else { $i = $i - $j + 2  ; 
           $j = 1  ; 
  } ; # tabA[i] = tabP[i]

} until ($j  >  $M)  or  ($i  >  $N) ; 


# affichage du rsultat

if ($j  >  $M) { 
   print $chP ." ". " vue dans " ." ". $chA ." ". "  partir de la position " ." ". ($i  -  $M)."\n" ; 
   }
 else { print $chP ." ". " non vue dans " ." ". $chA."\n" ; 
} ; # j>M


# dtail des tableaux (on suppose M < N)

print " Elment tableau P  tableau A "."\n" ; 

for ( $ind = 1  ;  $ind <= $N  ; $ind++ ) { 
   if (($ind  <=  $M)) { 
      $milieu = &concatene(&format($tabP[ $ind ] , 8 ) , &sousChaineZero($chP , $ind , 1 ) )  ; 
      }
 else { $milieu = &copies(" " , 10 )  ; 
   } ; # (ind<=M)
   print &format($ind , 3 ) ." ". " : " ." ". $milieu ." ". &format($tabA[ $ind ] , 8 ) ." ". &sousChaineZero($chA , $ind , 1 )."\n" ; 
} ; # ind de1a N

##-#  Ajout de sousChaineZero.pl via le code #> 

sub  sousChaineZero  {
  return( substr($_[0],$_[1]-1,$_[2]) ) ;
} ; # fin sub sousChaineZero

##-#  Fin d'ajout de sousChaineZero.pl via le code #> 
##-#  Ajout de format.pl via le code #> 

sub  format  {
  return( sprintf("%$_[1]d",$_[0]) ) ;
} ; # fin sub format

##-#  Fin d'ajout de format.pl via le code #> 
##-#  Ajout de concatene.pl via le code #> 

sub  concatene  { # met bout  bout deux chaines
  return( join(" ",@_) ) ;
} ; # fin sub concatene

##-#  Fin d'ajout de concatene.pl via le code #> 
##-#  Ajout de copies.pl via le code #> 

sub  copies  {
  return( $_[0] x $_[1] ) ;
} ; # fin sub copies

##-#  Fin d'ajout de copies.pl via le code #> 

##-#   Fin de traduction pour rchbrutePerl.pl via de galg -a rchbrutePerl.alg -o perl
