/* ##-#   Fichier macnaughtonRex.rex issu de galg -a macnaughtonRex.alg -o rexx */
/* ##-#  ====================================================================== */
/* ##-#      29/07/2001 11:49.32 */

/* ############################################################## */
/* #                                                            # */
/* #   macNaughton.alg : affectation de taches selon            # */
/* #                   la mthode de mac Naughton               # */
/* #   auteur (gH)                                              # */
/* #                                                            # */
/* #                                                            # */
/* ############################################################## */
/* #                                                            # */
/* #   rfrences ???                                           # */
/* #                                                            # */
/* #                                                            # */
/* ############################################################## */
/* #                                                            # */
/* #                                                            # */
/* # avec nbMachines qui doivent effectuer nbTaches et sachant  # */
/* # que la tache numro i dure dureeTache[ i] comment rpartir # */
/* # les taches ? la dure est en heure et les taches sont      # */
/* # morcelables heure par heure.                               # */
/* #                                                            # */
/* #                                                            # */
/* ############################################################## */

/* # 0.  Affectations arbitraires pour tester l'exemple fourni */
/* #     dans le cours vu sur le web  l'adresse */


nbMachines = 3 
nbTaches = 6 

dureeTache.1  = 5 
dureeTache.2  = 3 
dureeTache.3  = 4 
dureeTache.4  = 5 
dureeTache.5  = 2 
dureeTache.6  = 5 


/* # 1. Calcul de la dure minimale */

somDuree = 0 
do indTache=1 to nbTaches 
     dureeCour = dureeTache.indTache  
     somDuree = somDuree + dureeCour 
     if indTache = 1 
        then ; do ;  dureeMax = dureeCour 
        end ; else ; do ; 
              if dureeCour > dureeMax 
                 then ; do ;  dureeMax = dureeCour 
              end /* # dureeCour > dureeMAx */
     end /* # indTache=1 */
end /* # indTache de1a nbTaches */
dureeMin =  max(somDuree   /   nbMachines ,  dureeMax) 



/* # 2. Affectation des taches aux machines */


/* # 2.1 Initialisation du tableau de rpartititon */

do indTache=1 to nbTaches 
     nbTache.indTache  = 0 
     do indMachine=1 to nbMachines 
           machineTacheNumero.indTache.indMachine  = 0 
           machineTacheDuree.indTache.indMachine  = ( - 1) 
     end /* # indMachine de1a nbMachines */
end /* # indTache de1a nbTaches */


/* # 2.2 Boucle d'affectation */

tempsPris = 0 
machineCour = 1 

do indTache=1 to nbTaches 
    dureeCour = dureeTache.indTache  

    if tempsPris + dureeCour <= dureeMin 

       then ; do ;  /* # on peut affecter toute la tache a la machine courante */

             tacheCour = nbTache.machineCour  + 1 
             nbTache.machineCour  = tacheCour 
             machineTacheNumero.machineCour.tacheCour  = indTache 
             machineTacheDuree.machineCour.tacheCour  = dureeCour 
             tempsPris = tempsPris + dureeCour 
             if tempsPris = dureeMin 
                then ; do ;  machineCour = machineCour + 1 
                      tempsPris = 0 
             end /* # tempsPris = dureeMin */

       end ; else ; do ; /* # on n'a le droit d'affecter qu'une partie a la machine courante */

             tacheCour = nbTache.machineCour  + 1 
             nbTache.machineCour  = tacheCour 
             machineTacheNumero.machineCour.tacheCour  = indTache 
             resteTemps = dureeMin - tempsPris 
             machineTacheDuree.machineCour.tacheCour  = resteTemps 

             /* # et on affecte ce qui reste a la machine suivante */

             machineCour = machineCour + 1 
             tacheCour = nbTache.machineCour  + 1 
             nbTache.machineCour  = tacheCour 
             machineTacheNumero.machineCour.tacheCour  = indTache 
             machineTacheDuree.machineCour.tacheCour  = dureeCour - resteTemps 
             tempsPris = dureeCour - resteTemps 

    end /* # tempsPris+dureeTache[ tacheCour ] <=  dureeMin */

end /* # indTache de1a nbTaches */


/* # 3. Affichage des donnes et des rpartitions */

say " Il y avait " nbMachines " machines et " nbTaches " taches  rpartir." 
say " Voici la dure des taches : " 
say "   Tache    Dure (en heures)" 
do indTache=1 to nbTaches 
     say  format(indTache ,  8)  format(dureeTache.indTache  ,  8) 
end /* # indTache de1a nbTaches */


say "" 
say " La dure minimale calcule est " dureeMin " heures." 
say "" 


do indMachine=1 to nbMachines 
    say "  -- machine " indMachine " : " 
    nbTacheCour = nbTache.indMachine  
    if nbTacheCour > 0 
       then ; do ;  
             do indTache=1 to nbTacheCour 
                  dureeCour = machineTacheDuree.indMachine.indTache  
                  tacheCour = machineTacheNumero.indMachine.indTache  
                  say  copies("  " ,  6) " tache " tacheCour " dure " dureeCour 
             end /* # indTache de1 nbTacheCour */
    end /* # numMachine > 0 */
end /* # indTache de1a nbTaches */

/* ##-#   Fin de traduction pour macnaughtonRex.rex via de galg -a macnaughtonRex.alg -o rexx */
