/* ##-#   Fichier rchbruteRex.rex issu de galg -a rchbruteRex.alg -o rexx */
/* ##-#  ================================================================ */
/* ##-#      29/07/2001 11:54.48 */

/* ########################################################## */
/* #                                                        # */
/* #                                                        # */
/* #  rchbrut.alg : brutesearch, auteur (gH)                # */
/* #                                                        # */
/* #                                                        # */
/* ########################################################## */
/* #                                                        # */
/* # source : Algorithms, second edition                    # */
/* #          pages 279, 280                                # */
/* #          R. Sedgewick, Addison-Wesley 1988             # */
/* #                                                        # */
/* ########################################################## */
/* #                                                        # */
/* #                                                        # */
/* #  recherche "brute" du tableau P dans le tableau A      # */
/* #  (en anglais : P pour pattern, A pour array)           # */
/* #  les variables sont renommes tabP et tabA             # */
/* #  pour plus de lisibilit.   le tableau tabP contient   # */
/* #  les codes ascii de la phrase                          # */
/* #                                                        # */
/* #      "A STRING SEARCHING EXAMPLE CONSISTING OF..."     # */
/* #                                                        # */
/* #  et le tableau tabA ceux du mot   "STING"              # */
/* #                                                        # */
/* #                                                        # */
/* ########################################################## */


chP = "STING" 
chA = "A STRING SEARCHING EXAMPLE CONSISTING OF..." 

/* # conversion des chaines en tableaux */

M =  length(chP) 
do ind=1 to M 
  tabP.ind  =  c2d( substr(chP ,  ind ,  1)) 
end /* # ind de1a length(chP) */

N =  length(chA) 
do ind=1 to N 
  tabA.ind  =  c2d( substr(chA ,  ind ,  1)) 
end /* # ind de1a length(chA) */


/* # algorithme de recherche */

i = 1 
j = 1 

do until (j > M)  |  (i > N) 

  if tabA.i  = tabP.j  
     then ; do ;  i = i + 1 
           j = j + 1 
     end ; else ; do ; i = i - j + 2 
           j = 1 
  end /* # tabA[i] = tabP[i] */

end 


/* # affichage du rsultat */

if j > M 
   then ; do ;  say chP " vue dans " chA "  partir de la position " (i - M) 
   end ; else ; do ; say chP " non vue dans " chA 
end /* # j>M */


/* # dtail des tableaux (on suppose M < N) */

say " Elment tableau P  tableau A " 

do ind=1 to N 
   if (ind <= M) 
      then ; do ;  milieu =  concatene( format(tabP.ind  ,  8) ,   substr(chP ,  ind ,  1)) 
      end ; else ; do ; milieu =  copies(" " ,  10) 
   end /* # (ind<=M) */
   say  format(ind ,  3) " : " milieu  format(tabA.ind  ,  8)  substr(chA ,  ind ,  1) 
end /* # ind de1a N */

exit 

/* ##-#  Ajout de concatene.rex via le code #>  */

concatene: procedure
   parse arg debut , fin
return debut fin

/* ##-#  Fin d'ajout de concatene.rex via le code #>  */

/* ##-#   Fin de traduction pour rchbruteRex.rex via de galg -a rchbruteRex.alg -o rexx */
