##-#   Fichier macnaughtonTcl.tcl issu de galg -a macnaughtonTcl.alg -o tcl
##-#  =====================================================================
##-#      22/08/2001 13:4.17

##############################################################
#                                                            #
#   macNaughton.alg : affectation de taches selon            #
#                   la mthode de mac Naughton               #
#   auteur (gH)                                              #
#                                                            #
#                                                            #
##############################################################
#                                                            #
#   rfrences ???                                           #
#                                                            #
#                                                            #
##############################################################
#                                                            #
#                                                            #
# avec nbMachines qui doivent effectuer nbTaches et sachant  #
# que la tache numro i dure dureeTache[ i] comment rpartir #
# les taches ? la dure est en heure et les taches sont      #
# morcelables heure par heure.                               #
#                                                            #
#                                                            #
##############################################################

##-#  Ajout de copies.tcl via le code #>

proc  copies  { chaine nb } {
  set repete ""
  for  { set ind 1  }  { $ind <= $nb }   { set ind [ incr ind] }  {
    set repete "$repete$chaine"
  } ; # fin de pour ind
  return $repete
} ; # fin proc copies

##-#  Fin d'ajout de copies.tcl via le code #>
##-#  Ajout de _format.tcl via le code #>

proc  _format  { nombre longueur } {
  set chformat [append "%" $longueur "d"]
  return [format %$chformat $nombre]
} ; # fin proc _format


##-#  Fin d'ajout de _format.tcl via le code #>

# 0.  Affectations arbitraires pour tester l'exemple fourni
#     dans le cours vu sur le web  l'adresse


set nbMachines 3

set nbTaches 6


set dureeTache(1)  5

set dureeTache(2)  3

set dureeTache(3)  4

set dureeTache(4)  5

set dureeTache(5)  2

set dureeTache(6)  5



# 1. Calcul de la dure minimale

set somDuree 0

for  { set indTache 1  }    { $indTache  <= $nbTaches  }   { set indTache [ incr indTache ] }  {
     set dureeCour $dureeTache($indTache)

     set somDuree [expr "$somDuree + $dureeCour " ]


     if { $indTache == 1  } {
        set dureeMax $dureeCour

        } else {
              if { $dureeCour > $dureeMax  } {
                 set dureeMax $dureeCour

              } ; # dureeCour > dureeMAx
     } ; # indTache=1
} ; # indTache de1a nbTaches
set dureeDiv [expr "$somDuree / $nbMachines " ]

puts " 1."
puts $dureeDiv
puts $dureeMax
set dureeMin [max $dureeDiv $dureeMax ]
puts " 2."
puts $dureeMin



# 2. Affectation des taches aux machines


# 2.1 Initialisation du tableau de rpartititon

for  { set indTache 1  }    { $indTache  <= $nbTaches  }   { set indTache [ incr indTache ] }  {
     set nbTache($indTache)  0

     for  { set indMachine 1  }    { $indMachine  <= $nbMachines  }   { set indMachine [ incr indMachine ] }  {
           set machineTacheNumero($indTache,$indMachine)  0

           set machineTacheDuree($indTache,$indMachine)  [expr "(- 1) " ]


     } ; # indMachine de1a nbMachines
} ; # indTache de1a nbTaches


# 2.2 Boucle d'affectation

set tempsPris 0

set machineCour 1


for  { set indTache 1  }    { $indTache  <= $nbTaches  }   { set indTache [ incr indTache ] }  {
    set dureeCour $dureeTache($indTache)


    if { $tempsPris + $dureeCour <= $dureeMin  } {

       # on peut affecter toute la tache a la machine courante

             set tacheCour [expr "$nbTache($machineCour) + 1 " ]


             set nbTache($machineCour)  $tacheCour

             set machineTacheNumero($machineCour,$tacheCour)  $indTache

             set machineTacheDuree($machineCour,$tacheCour)  $dureeCour

             set tempsPris [expr "$tempsPris + $dureeCour " ]


             if { $tempsPris == $dureeMin  } {
                set machineCour [expr "$machineCour + 1 " ]


                      set tempsPris 0

             } ; # tempsPris = dureeMin

       } else { # on n'a le droit d'affecter qu'une partie a la machine courante

             set tacheCour [expr "$nbTache($machineCour) + 1 " ]


             set nbTache($machineCour)  $tacheCour

             set machineTacheNumero($machineCour,$tacheCour)  $indTache

             set resteTemps [expr "$dureeMin - $tempsPris " ]


             set machineTacheDuree($machineCour,$tacheCour)  $resteTemps


             # et on affecte ce qui reste a la machine suivante

             set machineCour [expr "$machineCour + 1 " ]


             set tacheCour [expr "$nbTache($machineCour) + 1 " ]


             set nbTache($machineCour)  $tacheCour

             set machineTacheNumero($machineCour,$tacheCour)  $indTache

             set machineTacheDuree($machineCour,$tacheCour)  [expr "$dureeCour - $resteTemps " ]


             set tempsPris [expr "$dureeCour - $resteTemps " ]



    } ; # tempsPris+dureeTache[ tacheCour ] <=  dureeMin

} ; # indTache de1a nbTaches


# 3. Affichage des donnes et des rpartitions

puts " Il y avait   $nbMachines  machines et  $nbTaches  taches  rpartir.  "
puts " Voici la dure des taches :  "
puts "   Tache    Dure (en heures) "
for  { set indTache 1  }    { $indTache  <= $nbTaches  }   { set indTache [ incr indTache ] }  {
     puts "[_format $indTache 8 ]  [_format $dureeTache($indTache) 8 ]  "
} ; # indTache de1a nbTaches


puts " "
puts " La dure minimale calcule est   $dureeMin  heures.  "
puts " "


for  { set indMachine 1  }    { $indMachine  <= $nbMachines  }   { set indMachine [ incr indMachine ] }  {
    puts "  -- machine   $indMachine  :  "
    set nbTacheCour $nbTache($indMachine)

    if { $nbTacheCour > 0  } {

             for  { set indTache 1  }    { $indTache  <= $nbTacheCour  }   { set indTache [ incr indTache ] }  {
                  set dureeCour [expr "$machineTacheDuree($indMachine,$indTache) " ]


                  set tacheCour [expr "$machineTacheNumero($indMachine,$indTache) " ]


                  puts "       tache   $tacheCour  dure  $dureeCour  "
             } ; # indTache de1 nbTacheCour
    } ; # numMachine > 0
} ; # indTache de1a nbTaches

##-#   Fin de traduction pour macnaughtonTcl.tcl via de galg -a macnaughtonTcl.alg -o tcl
