##-#   Fichier rchbruteTcl.tcl issu de galg -a rchbruteTcl.alg -o tcl
##-#  ===============================================================
##-#      24/08/2001 16:59.01

##########################################################
#                                                        #
#                                                        #
#  rchbrut.alg : brutesearch, auteur (gH)                #
#                                                        #
#                                                        #
##########################################################
#                                                        #
# source : Algorithms, second edition                    #
#          pages 279, 280                                #
#          R. Sedgewick, Addison-Wesley 1988             #
#                                                        #
##########################################################
#                                                        #
#                                                        #
#  recherche "brute" du tableau P dans le tableau A      #
#  (en anglais : P pour pattern, A pour array)           #
#  les variables sont renommes tabP et tabA             #
#  pour plus de lisibilit.   le tableau tabP contient   #
#  les codes ascii de la phrase                          #
#                                                        #
#      "A STRING SEARCHING EXAMPLE CONSISTING OF..."     #
#                                                        #
#  et le tableau tabA ceux du mot   "STING"              #
#                                                        #
#                                                        #
##########################################################

##-#  Ajout de sousChaine.tcl via le code #> 

proc  sousChaine  { chaine debut longueur } {
  return [string range $chaine [expr $debut-1] [expr $debut+$longueur-2] ]
} ; # fin proc sousChaine

##-#  Fin d'ajout de sousChaine.tcl via le code #> 
##-#  Ajout de codeAscii.tcl via le code #> 

proc  codeAscii  { caract } {

  return [scan $caract "%c"]

} ; # fin proc codeAscii

##-#  Fin d'ajout de codeAscii.tcl via le code #> 
##-#  Ajout de concatene.tcl via le code #> 

proc  concatene  { debut fin } {
  return "$debut$fin" ;
} ; # fin proc concatene

##-#  Fin d'ajout de concatene.tcl via le code #> 
##-#  Ajout de copies.tcl via le code #> 

proc  copies  { chaine nb } {
  set repete ""
  for  { set ind 1  }  { $ind <= $nb }   { set ind [ incr ind] }  {
    set repete "$repete$chaine"
  } ; # fin de pour ind
  return $repete
} ; # fin proc copies

##-#  Fin d'ajout de copies.tcl via le code #> 
##-#  Ajout de _format.tcl via le code #> 

proc  _format  { nombre longueur } {
  set chformat [append "%" $longueur "d"]
  return [format %$chformat $nombre]
} ; # fin proc _format


##-#  Fin d'ajout de _format.tcl via le code #> 

set chP "STING" 

set chA "A STRING SEARCHING EXAMPLE CONSISTING OF..." 


# conversion des chaines en tableaux

set M  [string length  $chP ]  

for  { set ind 1  }    { $ind  <= $M  }   { set ind [ incr ind ] }  { 
  set tabP($ind)  [codeAscii [sousChaine $chP $ind 1 ] ]  

} ; # ind de1a longueur(chP)

set N  [string length  $chA ]  

for  { set ind 1  }    { $ind  <= $N  }   { set ind [ incr ind ] }  { 
  set tabA($ind)  [codeAscii [sousChaine $chA $ind 1 ] ]  

} ; # ind de1a _longueur(chA)


# algorithme de recherche

set i 1 

set j 1 


## il n'y pas de structure REPETER en Tcl alors on
## remplace la boucle REPETER par une boucle TANT QUE
## rpter
while { ($j <= $M) && ($i <= $N) }  { 

  if { $tabA($i) == $tabP($j)  } { 
     set i [expr "$i + 1 " ]
 

           set j [expr "$j + 1 " ]
 

     } else { set i [expr "$i - $j + 2 " ]
 

           set j 1 

  } ; # tabA[i] = tabP[i]

## jusqu' (j>M) ou (i>N)
} ; # (j<=M) et (i<=N)


# affichage du rsultat

if { $j > $M  } { 
   set posVue [expr "$i - $M " ]
 

         puts "$chP  vue dans  $chA   partir de la position  $posVue  "
   } else { puts "$chP  non vue dans  $chA  "
} ; # j>M


# dtail des tableaux (on suppose M < N)

puts " Elment tableau P  tableau A  "

set espace " " 

for  { set ind 1  }    { $ind  <= $N  }   { set ind [ incr ind ] }  { 
   if { ($ind <= $M)  } { 
      set elementP $tabP($ind)  

            set milieu [concatene [_format $elementP 8 ] $espace ]  

            set milieu [concatene $milieu [sousChaine $chP $ind 1 ] ]  

      } else { set milieu [copies $espace 10 ]  

   } ; # (ind<=M)
   set elementA $tabA($ind)  

   puts "[_format $ind 3 ]  :  $milieu  [_format $elementA 8 ]  [sousChaine $chA $ind 1 ]  "
} ; # ind de1a N

##-#   Fin de traduction pour rchbruteTcl.tcl via de galg -a rchbruteTcl.alg -o tcl
