/* #-#   Fichier macnaughtonC.c issu de galg -a macnaughtonC.alg -o c */
/* #-#  ============================================================= */
/* #-#      19/09/2001 12:17.31 */

/* ############################################################# */
/*                                                             # */
/*    macNaughton.alg : affectation de taches selon            # */
/*                      la mthode de mac Naughton             # */
/*    auteur (gH)                                              # */
/*                                                             # */
/*                                                             # */
/* ############################################################# */
/*                                                             # */
/*    rfrences :  Cormen, Leiserson et Rivest                # */
/*                  Introduction to algorithms, MIT Press      # */
/*                                                             # */
/* ############################################################# */
/*                                                             # */
/*                                                             # */
/*  avec nbMachines qui doivent effectuer nbTaches et sachant  # */
/*  que la tache numro i dure dureeTache[ i] comment rpartir # */
/*  les taches ? la dure est en heure et les taches sont      # */
/*  morcelables heure par heure.                               # */
/*                                                             # */
/*                                                             # */
/* ############################################################# */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

 typedef char chaine[250] ;

/* #-#  Ajout de maxEntier.c via le code #>  */

int maxEntier(float un, float deux) {
  if (un>deux) { return (int) un   ; }
          else { return (int) deux ; } ;
} /* fin de maxEntier */


/* #-#  Fin d'ajout de maxEntier.c via le code #>  */
/* #-#  Ajout de ecrireEntier.c via le code #>  */

void ecrireEntier(float f) {
  printf("%d",(int) f) ;
  return ;
} /* fin de ecrireEntier */

/* #-#  Fin d'ajout de ecrireEntier.c via le code #>  */
/* #-#  Ajout de formatEntier.c via le code #>  */

char *formatEntier(int nombre,int longueur) {

  int      next ;
  char     qbuf[100] ;
  char     qbuf2[100] ;
  register int r, k ;
  int      flag = 0 ;

  next = 0 ;
  if (nombre <  0) { qbuf[next++] = '-' ; nombre = -nombre ; }
  if (nombre == 0) { qbuf[next++] = '0' ;   } else {
      k = 10000 ;
      while (k > 0) {
         r = nombre / k ;
         if (flag || r > 0) {
               qbuf[next++] = '0' + r ;
               flag = 1 ;
         } ; /* finde si flag ok */
         nombre -= r * k ;
         k       = k / 10 ;
        } ; /* fin de tant que k > 0 */
  } ; /* fin de si nombre non nul */
  qbuf[next] = 0 ;
  while (strlen(qbuf)<longueur) {
    strcpy(qbuf2," ")  ;
    strcat(qbuf2,qbuf) ;
    strcpy(qbuf,qbuf2) ;
  ; } ; /* fin de tant que chaine trop courte */

  return(qbuf);

} /* fin de formatEntier */

/* #-#  Fin d'ajout de formatEntier.c via le code #>  */
/* #-#  Ajout de copies.c via le code #>  */

char *copies(char *motif,int repet ) {

  int   k = 1 ;
  char  chaineRes[100] ;
  strcpy(chaineRes,"")  ;
  while (k <= repet) {
    strcat(chaineRes,motif) ;
    k++;
  ; } ; /* fin de tant que sur k */

  return(chaineRes) ;
} /* fin de copies */

/* #-#  Fin d'ajout de copies.c via le code #>  */

/* #-#  Ajout de macnaughtonC.inc via le code #>  */

 int main(void) {

     int nbMachines   = -1 ;
     int nbTaches     = -1 ;
     int indTache     = -1 ;
     int indMachine   = -1 ;
     int somDuree     =  0 ;
     int dureeCour    =  0 ;
     int dureeMax     =  0 ;
     int dureeMin     =  0 ;
     int tempsPris    =  0 ;
     int machineCour  =  0 ;
     int tacheCour    =  0 ;
     int resteTemps   =  0 ;
     int nbTacheCour  =  0 ;

     int dureeTache[10] ;
     int nbTache[10] ;
     int machineTacheNumero[10][10] ;
     int machineTacheDuree[10][10] ;

/* #-#  Fin d'ajout de macnaughtonC.inc via le code #>  */

/*  0.  Affectations arbitraires pour tester un */
/*      exemple lmentaire */


nbMachines = 3 ;
nbTaches = 6 ;

dureeTache[1] = 5 ;
dureeTache[2] = 3 ;
dureeTache[3] = 4 ;
dureeTache[4] = 5 ;
dureeTache[5] = 2 ;
dureeTache[6] = 5 ;


/*  1. Calcul de la dure minimale */

somDuree = 0 ;
for(indTache=1; indTache<=nbTaches; indTache++) { 
     dureeCour = dureeTache[indTache] ;
     somDuree = somDuree + dureeCour ;
     if (indTache == 1) { 
        dureeMax = dureeCour ;
        } else { 
              if (dureeCour > dureeMax) { 
                 dureeMax = dureeCour ;
              } ; /*  dureeCour > dureeMAx */
     } ; /*  indTache=1 */
} ; /*  indTache de1a nbTaches */
dureeMin = maxEntier(somDuree   /   nbMachines, dureeMax) ;



/*  2. Affectation des taches aux machines */


/*  2.1 Initialisation du tableau de rpartititon */

for(indTache=1; indTache<=nbTaches; indTache++) { 
     nbTache[indTache] = 0 ;
     for(indMachine=1; indMachine<=nbMachines; indMachine++) { 
           machineTacheNumero[indTache  ][ indMachine] = 0 ;
           machineTacheDuree[indTache  ][ indMachine] = ( - 1) ;
     } ; /*  indMachine de1a nbMachines */
} ; /*  indTache de1a nbTaches */


/*  2.2 Boucle d'affectation */

tempsPris = 0 ;
machineCour = 1 ;

for(indTache=1; indTache<=nbTaches; indTache++) { 
    dureeCour = dureeTache[indTache] ;

    if (tempsPris + dureeCour <= dureeMin) { 

       /*  on peut affecter toute la tache a la machine courante */

             tacheCour = nbTache[machineCour] + 1 ;
             nbTache[machineCour] = tacheCour ;
             machineTacheNumero[machineCour  ][ tacheCour] = indTache ;
             machineTacheDuree[machineCour  ][ tacheCour] = dureeCour ;
             tempsPris = tempsPris + dureeCour ;
             if (tempsPris == dureeMin) { 
                machineCour = machineCour + 1 ;
                      tempsPris = 0 ;
             } ; /*  tempsPris = dureeMin */

       } else { /*  on n'a le droit d'affecter qu'une partie a la machine courante */

             tacheCour = nbTache[machineCour] + 1 ;
             nbTache[machineCour] = tacheCour ;
             machineTacheNumero[machineCour  ][ tacheCour] = indTache ;
             resteTemps = dureeMin - tempsPris ;
             machineTacheDuree[machineCour  ][ tacheCour] = resteTemps ;

             /*  et on affecte ce qui reste a la machine suivante */

             machineCour = machineCour + 1 ;
             tacheCour = nbTache[machineCour] + 1 ;
             nbTache[machineCour] = tacheCour ;
             machineTacheNumero[machineCour  ][ tacheCour] = indTache ;
             machineTacheDuree[machineCour  ][ tacheCour] = dureeCour - resteTemps ;
             tempsPris = dureeCour - resteTemps ;

    } ; /*  tempsPris+dureeTache[ tacheCour ] <=  dureeMin */

} ; /*  indTache de1a nbTaches */


/*  3. Affichage des donnes et des rpartitions */

printf("%s"," Il y avait ") ;

ecrireEntier(nbMachines) ; 
printf("%s"," machines et ") ;

ecrireEntier(nbTaches) ; 
printf("%s"," taches  rpartir.") ;
puts("") ;


printf("%s"," Voici la dure des taches : ") ;
puts("") ;

printf("%s","   Tache    Dure (en heures)") ;
puts("") ;


for(indTache=1; indTache<=nbTaches; indTache++) { 
     printf("%s",formatEntier(indTache, 8)) ;

     printf("%s",formatEntier(dureeTache[indTache], 8)) ;
puts("") ;

} ; /*  indTache de1a nbTaches */


printf("%s","") ;
puts("") ;

printf("%s"," La dure minimale calcule est ") ;

ecrireEntier(dureeMin) ; 
printf("%s"," heures.") ;
puts("") ;

printf("%s","") ;
puts("") ;



for(indMachine=1; indMachine<=nbMachines; indMachine++) { 
    printf("%s","  -- machine ") ;

    ecrireEntier(indMachine) ; 
    printf("%s","") ;
puts("") ;

    nbTacheCour = nbTache[indMachine] ;
    if (nbTacheCour > 0) { 
       
             for(indTache=1; indTache<=nbTacheCour; indTache++) { 
                  dureeCour = machineTacheDuree[indMachine  ][ indTache] ;
                  tacheCour = machineTacheNumero[indMachine  ][ indTache] ;
                  printf("%s",copies("  ", 6)) ;

                  printf("%s"," tache ") ;

                  ecrireEntier(tacheCour) ; 
                  printf("%s"," dure ") ;

                  ecrireEntier(dureeCour) ; 
                  printf("%s","") ;
puts("") ;

             } ; /*  indTache de1 nbTacheCour */
    } ; /*  numMachine > 0 */
} ; /*  indTache de1a nbTaches */
return(0);
} /* fin de main */ 

/* #-#   Fin de traduction pour macnaughtonC.c via de galg -a macnaughtonC.alg -o c */
