//#-#   Fichier macnaughtonJava.java issu de galg -a macnaughtonJava.alg -o java
//#-#  =========================================================================
//#-#      04/10/2001 11:45.37

//#############################################################
//                                                            #
//   macNaughton.alg : affectation de taches selon            #
//                     la mthode de mac Naughton             #
//   auteur (gH)                                              #
//                                                            #
//                                                            #
//#############################################################
//                                                            #
//   rfrences :  Cormen, Leiserson et Rivest                #
//                 Introduction to algorithms, MIT Press      #
//                                                            #
//#############################################################
//                                                            #
//                                                            #
// avec nbMachines qui doivent effectuer nbTaches et sachant  #
// que la tache numro i dure dureeTache[ i] comment rpartir #
// les taches ? la dure est en heure et les taches sont      #
// morcelables heure par heure.                               #
//                                                            #
//                                                            #
//#############################################################

//#-#  La ligne suivante provient d'un ajout via le code #: 
import java.io.* ;
class macnaughtonJava { 


//#-#  Ajout de maxEntier.java via le code #> 

public static int maxEntier( int un, int deux) {
  if (un>deux) { return un ; } else { return deux ; } ;
} // fin de maxEntier

//#-#  Fin d'ajout de maxEntier.java via le code #> 
//#-#  Ajout de partieEntiere.java via le code #> 

static int partieEntiere(double nb_r) {
  return (int) nb_r ;
} // fin de partieEntiere

//#-#  Fin d'ajout de partieEntiere.java via le code #> 
//#-#  Ajout de format.java via le code #> 

public static String format(int nombre, int longueur) {

  String chen = Integer.toString(nombre) ;
  while (chen.length() < longueur) { chen = " " + chen ; } ;
  return chen ;

} // fin de format

//#-#  Fin d'ajout de format.java via le code #> 
//#-#  Ajout de copies.java via le code #> 

public static String copies(String motif, int repet) {

  String chen = "" ;
  for (int ifois =1 ; ifois <= repet ; ifois++) {
      chen = motif + chen ;
  } ; // fin de pour

  return chen ;

} // fin de copies

//#-#  Fin d'ajout de copies.java via le code #> 

//#-#  La ligne suivante provient d'un ajout via le code #: 
public static void main(String args[]) {
//#-#  La ligne suivante provient d'un ajout via le code #: 
// dbut de la mthode main()


//#-#  La ligne suivante provient d'un ajout via le code #: 
int     nbMachines    = -1  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int     nbTaches      = -1  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int[]   dureeTache          ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int     somDuree      =  0  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int     dureeCour     =  0  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int     dureeMax      =  0  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int     dureeMin      =  0  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int[]   nbTache             ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int[][] machineTacheNumero  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int[][] machineTacheDuree   ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int     tempsPris     =  0  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int     machineCour   =  0  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int     tacheCour     =  0  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int     resteTemps    =  0  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int     nbTacheCour   =  0  ;


// 0.  Affectations arbitraires pour tester un
//     exemple lmentaire


nbMachines = 3 ;
nbTaches = 6 ;

//#-#  La ligne suivante provient d'un ajout via le code #: 
dureeTache         = new int[ nbTaches + 1 ] ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
nbTache            = new int[ nbTaches + 1 ] ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
machineTacheNumero = new int[ nbTaches + 1 ][ nbMachines + 1 ] ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
machineTacheDuree  = new int[ nbTaches + 1 ][ nbMachines + 1 ] ;

dureeTache[1] = 5 ;
dureeTache[2] = 3 ;
dureeTache[3] = 4 ;
dureeTache[4] = 5 ;
dureeTache[5] = 2 ;
dureeTache[6] = 5 ;


// 1. Calcul de la dure minimale

somDuree = 0 ;
for (int indTache=1; indTache<=nbTaches; indTache++) { 
     dureeCour = dureeTache[indTache] ;
     somDuree = somDuree + dureeCour ;
     if (indTache == 1) { 
        dureeMax = dureeCour ;
        }
else
{ 
              if (dureeCour > dureeMax) { 
                 dureeMax = dureeCour ;
              } ; // dureeCour > dureeMAx
     } ; // indTache=1
} ; // indTache de1a nbTaches
dureeMin = maxEntier(partieEntiere(somDuree / nbMachines), dureeMax) ;


// 2. Affectation des taches aux machines


// 2.1 Initialisation du tableau de rpartititon

for (int indTache=1; indTache<=nbTaches; indTache++) { 
     nbTache[indTache] = 0 ;
     for (int indMachine=1; indMachine<=nbMachines; indMachine++) { 
           machineTacheNumero[indTache  ][ indMachine] = 0 ;
           machineTacheDuree[indTache  ][ indMachine] = ( - 1) ;
     } ; // indMachine de1a nbMachines
} ; // indTache de1a nbTaches

// 2.2 Boucle d'affectation

tempsPris = 0 ;
machineCour = 1 ;

for (int indTache=1; indTache<=nbTaches; indTache++) { 
    dureeCour = dureeTache[indTache] ;

    if (tempsPris + dureeCour <= dureeMin) { 

       // on peut affecter toute la tache a la machine courante

             tacheCour = nbTache[machineCour] + 1 ;
             nbTache[machineCour] = tacheCour ;
             machineTacheNumero[machineCour  ][ tacheCour] = indTache ;
             machineTacheDuree[machineCour  ][ tacheCour] = dureeCour ;
             tempsPris = tempsPris + dureeCour ;
             if (tempsPris == dureeMin) { 
                machineCour = machineCour + 1 ;
                      tempsPris = 0 ;
             } ; // tempsPris = dureeMin

       }
else
{ // on n'a le droit d'affecter qu'une partie a la machine courante

             tacheCour = nbTache[machineCour] + 1 ;
             nbTache[machineCour] = tacheCour ;
             machineTacheNumero[machineCour  ][ tacheCour] = indTache ;
             resteTemps = dureeMin - tempsPris ;
             machineTacheDuree[machineCour  ][ tacheCour] = resteTemps ;

             // et on affecte ce qui reste a la machine suivante

             machineCour = machineCour + 1 ;
             tacheCour = nbTache[machineCour] + 1 ;
             nbTache[machineCour] = tacheCour ;
             machineTacheNumero[machineCour  ][ tacheCour] = indTache ;
             machineTacheDuree[machineCour  ][ tacheCour] = dureeCour - resteTemps ;
             tempsPris = dureeCour - resteTemps ;

    } ; // tempsPris+dureeTache[ tacheCour ] <=  dureeMin

} ; // indTache de1a nbTaches


// 3. Affichage des donnes et des rpartitions

 System.out.println(" Il y avait "+nbMachines+" machines et "+nbTaches+" taches  rpartir.") ;

 System.out.println(" Voici la dure des taches : ") ;

 System.out.println("   Tache    Dure (en heures)") ;

for (int indTache=1; indTache<=nbTaches; indTache++) { 
      System.out.println(format(indTache, 8)+format(dureeTache[indTache], 8)) ;

} ; // indTache de1a nbTaches


 System.out.println("") ;

 System.out.println(" La dure minimale calcule est "+dureeMin+" heures.") ;

 System.out.println("") ;



for (int indMachine=1; indMachine<=nbMachines; indMachine++) { 
     System.out.println("  -- machine "+indMachine+" : ") ;

    nbTacheCour = nbTache[indMachine] ;
    if (nbTacheCour > 0) { 
       
             for (int indTache=1; indTache<=nbTacheCour; indTache++) { 
                  dureeCour = machineTacheDuree[indMachine  ][ indTache] ;
                  tacheCour = machineTacheNumero[indMachine  ][ indTache] ;
                   System.out.println(copies("  ", 6)+" tache "+tacheCour+" dure "+dureeCour) ;

             } ; // indTache de1 nbTacheCour
    } ; // numMachine > 0
} ; // indTache de1a nbTaches
} // fin de la mthode main()
} // fin de la classe macnaughtonJava 

//#-#   Fin de traduction pour macnaughtonJava.java via de galg -a macnaughtonJava.alg -o java
