/* #-#   Fichier rchbruteC.c issu de galg -a rchbruteC.alg -o c */
/* #-#  ======================================================= */
/* #-#      19/09/2001 12:20.34 */

/* ######################################################### */
/*                                                         # */
/*                                                         # */
/*   rchbrut.alg : brutesearch, auteur (gH)                # */
/*                                                         # */
/*                                                         # */
/* ######################################################### */
/*                                                         # */
/*  source : Algorithms, second edition                    # */
/*           pages 279, 280                                # */
/*           R. Sedgewick, Addison-Wesley 1988             # */
/*                                                         # */
/* ######################################################### */
/*                                                         # */
/*                                                         # */
/*   recherche "brute" du tableau P dans le tableau A      # */
/*   (en anglais : P pour pattern, A pour array)           # */
/*   les variables sont renommes tabP et tabA             # */
/*   pour plus de lisibilit.   le tableau tabP contient   # */
/*   les codes ascii de la phrase                          # */
/*                                                         # */
/*       "A STRING SEARCHING EXAMPLE CONSISTING OF..."     # */
/*                                                         # */
/*   et le tableau tabA ceux du mot   "STING"              # */
/*                                                         # */
/*                                                         # */
/* ######################################################### */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

 typedef char chaine[250] ;

/* #-#  Ajout de caractereNumero.c via le code #>  */

int caractereNumero(chaine ancienne, int debut) {
  return(ancienne[debut-1]) ;
} /* fin de caractereNumero */

/* #-#  Fin d'ajout de caractereNumero.c via le code #>  */
/* #-#  Ajout de formatEntier.c via le code #>  */

char *formatEntier(int nombre,int longueur) {

  int      next ;
  char     qbuf[100] ;
  char     qbuf2[100] ;
  register int r, k ;
  int      flag = 0 ;

  next = 0 ;
  if (nombre <  0) { qbuf[next++] = '-' ; nombre = -nombre ; }
  if (nombre == 0) { qbuf[next++] = '0' ;   } else {
      k = 10000 ;
      while (k > 0) {
         r = nombre / k ;
         if (flag || r > 0) {
               qbuf[next++] = '0' + r ;
               flag = 1 ;
         } ; /* finde si flag ok */
         nombre -= r * k ;
         k       = k / 10 ;
        } ; /* fin de tant que k > 0 */
  } ; /* fin de si nombre non nul */
  qbuf[next] = 0 ;
  while (strlen(qbuf)<longueur) {
    strcpy(qbuf2," ")  ;
    strcat(qbuf2,qbuf) ;
    strcpy(qbuf,qbuf2) ;
  ; } ; /* fin de tant que chaine trop courte */

  return(qbuf);

} /* fin de formatEntier */

/* #-#  Fin d'ajout de formatEntier.c via le code #>  */
/* #-#  Ajout de sousChaine.c via le code #>  */

char* sousChaine(chaine ancienne, int debut, int longueur) {
chaine nouvelle ;
int ic ;
  strcpy(nouvelle,ancienne) ;
  if (debut<0) { debut = 0 ; } ;
  if (longueur>strlen(ancienne)) { longueur = strlen(ancienne) ; } ;
  nouvelle[longueur] = 0 ;
  for (ic=0;ic<strlen(nouvelle);ic++) {
    nouvelle[ic] = ancienne[debut+ic-1] ;
  } ;
  return(nouvelle) ;
} /* fin de sousChaine */

/* #-#  Fin d'ajout de sousChaine.c via le code #>  */
/* #-#  Ajout de concatene.c via le code #>  */

 char* concatene(chaine un, chaine deux) {
  chaine res ;
  strcpy(res,un) ;
  strcat(res,deux) ;
  return( res ) ;
} /* fin de concatene */


/* #-#  Fin d'ajout de concatene.c via le code #>  */
/* #-#  Ajout de copies.c via le code #>  */

char *copies(char *motif,int repet ) {

  int   k = 1 ;
  char  chaineRes[100] ;
  strcpy(chaineRes,"")  ;
  while (k <= repet) {
    strcat(chaineRes,motif) ;
    k++;
  ; } ; /* fin de tant que sur k */

  return(chaineRes) ;
} /* fin de copies */

/* #-#  Fin d'ajout de copies.c via le code #>  */
/* #-#  Ajout de ecrireEntier.c via le code #>  */

void ecrireEntier(float f) {
  printf("%d",(int) f) ;
  return ;
} /* fin de ecrireEntier */

/* #-#  Fin d'ajout de ecrireEntier.c via le code #>  */

/* #-#  Ajout de rchbruteC.inc via le code #>  */

int main(int argc, char *argv[]) {

chaine chP ;
chaine chA ;
int tabP[250] ;
int tabA[250] ;
int ind ;
int i ;
int j ;
int M ;
int N ;
chaine milieu ;
chaine feltp ;
chaine seltp ;
chaine espb ;
chaine fe ;

/* #-#  Fin d'ajout de rchbruteC.inc via le code #>  */

strcpy(chP, "STING") ; 
strcpy(chA, "A STRING SEARCHING EXAMPLE CONSISTING OF...") ; 

/*  conversion des chaines en tableaux */

M = strlen(chP) ;
for(ind=1; ind<=M; ind++) { 
  tabP[ind] = (int) (caractereNumero(chP, ind)) ;
} ; /*  ind de1a longueur(chP) */

N = strlen(chA) ;
for(ind=1; ind<=N; ind++) { 
  tabA[ind] = (int) (caractereNumero(chA, ind)) ;
} ; /*  ind de1a longueur(chA) */


/*  algorithme de recherche */

i = 1 ;
j = 1 ;

/* rpter */
while ((j <= M) && (i <= N)) { 

  if (tabA[i] == tabP[j]) { 
     i = i + 1 ;
           j = j + 1 ;
     } else { i = i - j + 2 ;
           j = 1 ;
  } ; /*  tabA[i] = tabP[i] */

/* jusqu' (j>M) ou (i>N) */
} ; /*  (j<=M) et (i<=N) */


/*  affichage du rsultat */

if (j > M) { 
   printf("%s",chP) ;

         printf("%s"," vue dans ") ;

         printf("%s",chA) ;

         printf("%s","  partir de la position ") ;

         ecrireEntier(i - M) ; 
         printf("%s","") ;
puts("") ;

   } else { printf("%s",chP) ;

         printf("%s",chP) ;

         printf("%s"," non vue dans ") ;

         printf("%s",chA) ;
puts("") ;

} ; /*  j>M */


/*  dtail des tableaux (on suppose M < N) */

printf("%s"," Elment tableau P  tableau A ") ;
puts("") ;


strcpy(espb, " ") ; 
for(ind=1; ind<=N; ind++) { 
   if ((ind <= M)) { 
      strcpy(feltp, formatEntier(tabP[ind], 8)) ; 
            strcpy(seltp, sousChaine(chP, ind, 1)) ; 
            strcpy(fe, concatene(feltp, espb)) ; 
            strcpy(milieu, concatene(fe, seltp)) ; 
      } else { strcpy(milieu, copies(" ", 10)) ; 
   } ; /*  (ind<=M) */
   printf("%s",formatEntier(ind, 3)) ;

   printf("%s"," : ") ;

   printf("%s",milieu) ;

   printf("%s",formatEntier(tabA[ind], 8)) ;

   printf("%s"," ") ;

   printf("%s",sousChaine(chA, ind, 1)) ;
puts("") ;

} ; /*  ind de1a N */
return(0);
} /* fin de main */ 

/* #-#   Fin de traduction pour rchbruteC.c via de galg -a rchbruteC.alg -o c */
