(* ##-#   Fichier rchbrutepascal.pas issu de galg -a rchbrutepascal.alg -o pascal *)
(* ##-#  ======================================================================== *)
(* ##-#      03/08/2001 23:35.27 *)

(* ########################################################## *)
(* #                                                        # *)
(* #                                                        # *)
(* #  rchbrut.alg : brutesearch, auteur (gH)                # *)
(* #                                                        # *)
(* #                                                        # *)
(* ########################################################## *)
(* #                                                        # *)
(* # source : Algorithms, second edition                    # *)
(* #          pages 279, 280                                # *)
(* #          R. Sedgewick, Addison-Wesley 1988             # *)
(* #                                                        # *)
(* ########################################################## *)
(* #                                                        # *)
(* #                                                        # *)
(* #  recherche "brute" du tableau P dans le tableau A      # *)
(* #  (en anglais : P pour pattern, A pour array)           # *)
(* #  les variables sont renommes tabP et tabA             # *)
(* #  pour plus de lisibilit.   le tableau tabP contient   # *)
(* #  les codes ascii de la phrase                          # *)
(* #                                                        # *)
(* #      "A STRING SEARCHING EXAMPLE CONSISTING OF..."     # *)
(* #                                                        # *)
(* #  et le tableau tabA ceux du mot   "STING"              # *)
(* #                                                        # *)
(* #                                                        # *)
(* ########################################################## *)

PROGRAM rchbrutepascal ; 


(* ##-#  Ajout de format.pas via le code #>  *)

function format( nombre : integer ; longueur : integer ) : string ;
  var chaine : string ;
begin
  str(nombre:longueur,chaine) ;
  format := chaine ;
end ;

(* ##-#  Fin d'ajout de format.pas via le code #>  *)
(* ##-#  Ajout de copies.pas via le code #>  *)

function copies( motif : string ; repet : integer ) : string ;
 var ind : integer ; chaine : string ;
begin
  chaine := '' ;
  for ind := 1 to repet do begin
      chaine := chaine + motif ;
  end ;
  copies := chaine ;
end ;

(* ##-#  Fin d'ajout de copies.pas via le code #>  *)
(* ##-#  Ajout de concatene.pas via le code #>  *)

function concatene( chaineA, chaineB : string ) : string ;
begin
 concatene := chaineA + chaineB ;
end ;

(* ##-#  Fin d'ajout de concatene.pas via le code #>  *)
(* ##-#  Ajout de sousChaine.pas via le code #>  *)

function sousChaine( chaine : string ; debut, longueur : integer ) : string ;
  var ind : integer ; sChaine : string ;
begin
  sChaine := '' ;
  for ind := 1 to longueur do begin
      sChaine := sChaine + chaine[ debut + ind - 1 ] ;
  end ;
  sousChaine := sChaine ;
end ;

(* ##-#  Fin d'ajout de sousChaine.pas via le code #>  *)
(* ##-#  Ajout de codeAscii.pas via le code #>  *)

function codeAscii( chaine : string ) : integer ;
begin
  codeAscii := ord( chaine[ 1 ] ) ;
end ;

(* ##-#  Fin d'ajout de codeAscii.pas via le code #>  *)

(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
var
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
chP    : string  ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
chA    : string  ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
M      : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
tabP   : array[1..100] of integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
N      : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
tabA   : array[1..100] of integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
i      : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
ind    : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
j      : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
milieu : string  ;


(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
BEGIN


chP := 'STING' ;
chA := 'A STRING SEARCHING EXAMPLE CONSISTING OF...' ;

(* # conversion des chaines en tableaux *)

M :=  length(chP)  ;
for ind := 1 to M do begin 
  tabP[ ind ] :=  codeAscii( sousChaine(chP ,  ind ,  1) )  ;
end ; (* # ind de1a longueur(chP) *)

N :=  length(chA)  ;
for ind := 1 to N do begin 
  tabA[ ind ] :=  codeAscii( sousChaine(chA ,  ind ,  1) )  ;
end ; (* # ind de1a longueur(chA) *)


(* # algorithme de recherche *)

i := 1 ;
j := 1 ;

repeat 

  if tabA[ i ]  =  tabP[ j ] 
     then begin  i := i  +  1 ;
           j := j  +  1 ;
     end else begin i := i  -  j  +  2 ;
           j := 1 ;
  end ; (* # tabA[i] = tabP[i] *)

until (j  >  M)  or  (i  >  N) ; 


(* # affichage du rsultat *)

if j  >  M 
   then begin  writeln( chP,' vue dans ',chA,'  partir de la position ',(i  -  M) ) ; 
   end else begin writeln( chP,' non vue dans ',chA ) ; 
end ; (* # j>M *)


(* # dtail des tableaux (on suppose M < N) *)

writeln( ' Elment tableau P  tableau A ' ) ; 

for ind := 1 to N do begin 
   if (ind  <=  M) 
      then begin  milieu :=  concatene( format(tabP[ ind ] ,  8)  ,  ' ')  ;
            milieu :=  concatene(milieu ,   sousChaine(chP ,  ind ,  1) )  ;
      end else begin milieu :=  copies(' ' ,  10)  ;
   end ; (* # (ind<=M) *)
   writeln(  format(ind ,  3) ,' : ',milieu, format(tabA[ ind ] ,  8) ,' ', sousChaine(chA ,  ind ,  1)  ) ; 
end ; (* # ind de1a N *)

END.

(* ##-#   Fin de traduction pour rchbrutepascal.pas via de galg -a rchbrutepascal.alg -o pascal *)
