(* ##-#   Fichier trifuspascal.pas issu de galg -a trifuspascal.alg -o pascal *)
(* ##-#  ==================================================================== *)
(* ##-#      03/10/2001 17:52.14 *)

(* # triFus.alg : trifusion de 2 fichiers dj tris *)
(* #              auteur -- gH *)

PROGRAM trifuspascal ; 



(* ##-#  Ajout de trifuspascal.var via le code #>  *)

var

    ligne1 : string ;
    ligne2 : string ;

    nbl1   : integer ;
    nbl2   : integer ;
    nbl3   : integer ;

    nomFic1  : string ;
    nomFic2  : string ;
    nomFic3  : string ;

    fic1 :  text ;  (* fichier d'entre numro 1 *)
    fic2 :  text ;  (* fichier d'entre numro 2 *)
    fic3 :  text ;  (* fichier de sortie *)

function format( nombre : integer ; longueur : integer ) : string ;
  var chaine : string ;
begin
  str(nombre:longueur,chaine) ;
  format := chaine ;
end ;

function mot ( PHR : string ; X : integer) : string ;
(* renvoie le Xeme mot de PHR ou vide *)
    const sep = ' ' ;	(*seul separateur valide "LE BLANC *)
    var nb	: integer ; (* compteur des mots *)
        i	: integer ; (* indice de caractere dans le mot *)
        L   : integer ; (* longueur de la chaine PHR *)
        debut_mot, fin_mot :  integer ;
            (* indice de dbut et de fin du mot dans PHR *)
        lemot : string ;
    begin (* de la function mot *)
       nb    := 0 ;
       PHR   := PHR + sep ;
       L   := length(PHR) ;
       i   := 1 ;
       while (i <= L ) and ( NB < (X-1) ) do begin
          if (PHR[i]=sep) then begin
             nb := nb + 1 ;
             while (i <= L ) and (PHR[i]=sep) do i := i + 1 ;
          end ; (* finsi PHR[i]=sep) *)
          i := i + 1
       end ; (* while ( i <=  L ) and ... *)
    (* le dbut est donc trouv ; cherchons la fin *)
       debut_mot := i ;
       while (i<=L ) do begin
          if PHR[i] <> sep   then    i := i + 1
                else    begin fin_mot    := i ;
                             i    := L + 1
                   end ;
       end ; (* i<= L *)
       if fin_mot > debut_mot
          then lemot := copy(PHR,debut_mot-1,fin_mot -debut_mot)
          else lemot := '' ;
       mot := lemot ;
    end ; (* function  mot  *)

(* ##-#  Fin d'ajout de trifuspascal.var via le code #>  *)

(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
BEGIN

(* # nommage des variables pour noms de fichier *)

nomFic1 := 'triFus.f1' ;
nomFic2 := 'triFus.f2' ;
nomFic3 := 'triFus.f3' ;

(* # initialisation des nombres de lignes lues et crites *)

nbl1 := 0 ;
nbl2 := 0 ;
nbl3 := 0 ;

(* # ouverture des 3 fichiers *)

assign( fic1 , nomFic1 ) ; reset( fic1 ) ; 
assign( fic2 , nomFic2 ) ; reset( fic2 ) ; 
assign( fic3 ,  nomFic3 ) ; rewrite( fic3 ) ; 

(* # lecture du premier enregistrement sur fic1 *)

if   not   eof(fic1)  
   then begin  (* # lecture possible *)
         readln( fic1 , ligne1 ) ; 
         nbl1 := nbl1  +  1 ;
end ; (* # lecture du fic1 *)

(* # lecture du premier enregistrement sur fic2 *)

if   not   eof(fic2)  
   then begin  (* # lecture possible *)
         readln( fic2 , ligne2 ) ; 
         nbl2 := nbl2  +  1 ;
end ; (* # lecture du fic1 *)

(* # boucle de tri-fusion *)

while ( (  not   eof(fic1) )  and  (  not   eof(fic2) ) ) do begin 
  if  mot(ligne1 ,  2)   <=   mot(ligne2 ,  2)  
     then begin  (* # criture de fic1 vers fic3 *)
            writeln( fic3 , ' (fic1) ',ligne1 ) ; 
            nbl3 := nbl3  +  1 ;
            if (  not   eof(fic1) ) 
               then begin  (* # lecture possible *)
                     readln( fic1 , ligne1 ) ; 
                     nbl1 := nbl1  +  1 ;
               end else begin ligne1 := '' ;
            end ; (* # lecture du fic1 *)
     end else begin (* # criture de fic2 vers fic3 *)
            writeln( fic3 , ' (fic2) ',ligne2 ) ; 
            nbl3 := nbl3  +  1 ;
            if (  not   eof(fic2) ) 
               then begin  (* # lecture possible *)
                     readln( fic2 , ligne2 ) ; 
                     nbl2 := nbl2  +  1 ;
               end else begin ligne2 := '' ;
            end ; (* # lecture du fic2 *)
  end ; (* # comparaison ligne 1 et ligne 2 *)
end ; (* # lecture sur les deux fichiers *)

if ( length(ligne1)   >  0)  and  ( length(ligne2)   >  0) 
     then begin  
           if  mot(ligne1 ,  2)   <=   mot(ligne2 ,  2)  
              then begin  (* # criture de fic1 vers fic3 *)
                     writeln( fic3 , ' (fic1) ',ligne1 ) ; 
                     nbl3 := nbl3  +  1 ;
                     writeln( fic3 , ' (fic2) ',ligne2 ) ; 
                     nbl3 := nbl3  +  1 ;
              end else begin (* # criture de fic2 vers fic3 *)
                     writeln( fic3 , ' (fic2) ',ligne2 ) ; 
                     nbl3 := nbl3  +  1 ;
                     writeln( fic3 , ' (fic1) ',ligne1 ) ; 
                     nbl3 := nbl3  +  1 ;
           end ; (* # comparaison ligne 1 et ligne 2 *)
end ; (* # on compare en fin de fichier *)

(* # s'il reste des lignes dans f1, on recopie f1 *)

while (   not   eof(fic1)  ) do begin 
     readln( fic1 , ligne1 ) ; 
     nbl1 := nbl1  +  1 ;
     writeln( fic3 , ' [fic1] ',ligne1 ) ; 
     nbl3 := nbl3  +  1 ;
end ; (* # lecture sur f1 *)

(* # s'il reste des lignes dans f2, on recopie f2 *)

while (   not   eof(fic2)  ) do begin 
     readln( fic2 , ligne2 ) ; 
     nbl2 := nbl2  +  1 ;
     writeln( fic3 , ' [fic2] ',ligne2 ) ; 
     nbl3 := nbl3  +  1 ;
end ; (* # lecture sur f1 *)

(* # fermeture des fichiers *)

close( fic1 ) ; 
close( fic2 ) ; 
close( fic3 ) ; 

(* # affichage du nombre de lignes lues et crites : *)

writeln( '    ', format(nbl1 ,  4) ,' lignes lues    sur ',nomFic1 ) ; 
writeln( '    ', format(nbl2 ,  4) ,' lignes lues    sur ',nomFic2 ) ; 
writeln( '    ', format(nbl3 ,  4) ,' lignes crites sur ',nomFic3 ) ; 

halt ; 

END.

(* ##-#   Fin de traduction pour trifuspascal.pas via de galg -a trifuspascal.alg -o pascal *)
